Package: OnassisJavaLibs
Type: Package
Title: OnassisJavaLibs, java libraries to run conceptmapper and
        semantic similarity
Version: 1.32.0
Author: Eugenia Galeota
Authors@R: person("Eugenia", "Galeota",
        email="eugenia.galeota@gmail.com", role=c("aut", "cre"))
Maintainer: Eugenia Galeota <eugenia.galeota@gmail.com>
Description: A package that contains java libraries to call
        conceptmapper and compute semnatic similarity from R
License: GPL-2
Depends: R (>= 3.4)
Imports: rJava
Suggests: BiocStyle, rmarkdown, knitr
VignetteBuilder: rmarkdown, knitr
SystemRequirements: Java (>= 1.8)
Encoding: UTF-8
biocViews: ExperimentData
NeedsCompilation: no
RoxygenNote: 6.0.1
git_url: https://git.bioconductor.org/packages/OnassisJavaLibs
git_branch: RELEASE_3_22
git_last_commit: 28145a9
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-11-04
Packaged: 2025-11-04 16:35:15 UTC; biocbuild

Slib
====

`Slib` is a JAVA library dedicated to semantic data mining based on texts and/or ontology processing. The library is composed of various modules dedicated to specific treatments - they can be used in the context of information retrieval, data analysis, recommendation system design...


* *slib-sml*, the module dedicated to [The Semantic Measures Library](http://www.semantic-measures-library.org) (SML), a library dedicated to semantic measures (similarity/relatedness) computation, evaluation and analysis. See dedicated web site: http://www.semantic-measures-library.org for more information on both semantic measures and this module.

* *slib-graph* a simple in-memory graph engine used to manipulate graphs of URIs - based on on the sesame library (RDF/OWL data loading...). This module provides an easy way to process semantic graphs (e.g. RDF graph) as graphs in which traversal can easily be performed. Numerous algorithms commonly used to process semantic graphs are implemented.
                                                                                 
* *slib-tools* various command-line tools performing processes on semantic graph/data
    * [SML-Toolkit](https://github.com/sharispe/slib/tree/master/slib-tools/slib-tools-sml-toolkit), a command-line tool dedicated to semantic similarity/relatedness computation.
    * Ontofocus, a command-line tool which can be used to perform efficient transitive reductions on potentially large taxonomies.
    
* *slib-utils* SLIB Utility classes
* *slib-indexer* Module which provides easy-to-use utility classes for indexing specific datasets.
* *slib-example* Source code examples


## Licence

[Cecill license](http://www.cecill.info/licences.en.html): a free software license adapted to both international and French legal matters, in the spirit of and retaining compatibility with the GNU General Public License (src: Wikipedia).
        

Sglib - Semantic Graph Library
========================

Sglib is a JAVA library dedicated to in memory semantic graph processing.
The graph model considered is based on:
- vertices as URI
- edges as triplet <s,p,o> of URIs



        

## ----echo=TRUE, eval=TRUE-----------------------------------------------------

require(rJava)

#Initializing the JVM
.jinit()

#Adding the path to the jar file
jarfilePath <- file.path(system.file('extdata', 'java', 'conceptmapper-0.0.1-SNAPSHOT-jar-with-dependencies.jar', package='OnassisJavaLibs'))

.jaddClassPath(jarfilePath)

#Creating an instance of the OntologyUtil with the sample obo file
ontoutil <- .jnew("edu.ucdenver.ccp.datasource.fileparsers.obo.OntologyUtil", .jnew('java/io/File', file.path(system.file('extdata', 'sample.cs.obo', package='OnassisJavaLibs'))))

#Creating the output file containing the conceptmapper dictionary
outputFile = .jnew("java/io/File", "dict.xml")

#Building of the dictionary from the OBO ontology
dictionary <- J("edu.ucdenver.ccp.nlp.wrapper.conceptmapper.dictionary.obo.OboToDictionary")$buildDictionary(
  outputFile,
  ontoutil,
  .jnull(),
  J("edu.ucdenver.ccp.datasource.fileparsers.obo.OntologyUtil")$SynonymType$EXACT
)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------

#Adding the similarity library containing the similarity class to compute semantic similarities
jarfilePath <- file.path(system.file('extdata', 'java', 'similarity-0.0.1-SNAPSHOT-jar-with-dependencies.jar', package='OnassisJavaLibs'))

.jaddClassPath(jarfilePath)

#Creating an instance of the class Similarity
similarity <- .jnew("iit/comp/epigen/nlp/similarity/Similarity")


#Loading the ontology in a grah structure
file_obo <- file.path(system.file('extdata', 'sample.cs.obo', package='OnassisJavaLibs'))

ontology_graph <- similarity$loadOntology(file_obo)

#Setting the semantic similarity measures 
measure_configuration <- similarity$setPairwiseConfig('resnik', 'seco')

#Terms of the ontologies need to be converted into URIs

term1 <- 'http://purl.obolibrary.org/obo/CL_0000771'
  
term2 <- 'http://purl.obolibrary.org/obo/CL_0000988'

URI1 <- .jcast(similarity$createURI(term1), new.class = "org.openrdf.model.URI", check = FALSE, convert.array = FALSE)

URI2 <- .jcast(similarity$createURI(term2), new.class = "org.openrdf.model.URI", check = FALSE, convert.array = FALSE)

# Computation of the semantic similarity score

similarity_score <- .jcall(similarity, "D", "pair_similarity", URI1, URI2, .jcast(ontology_graph, new.class = "slib.graph.model.graph.G"), measure_configuration)

similarity_score

#!/usr/bin/Rscript



version	  <- "0.0.4"
cat("------------------------------------------------\n")
cat(" SML-sme: ROC analysis ",version,"\n")
cat("------------------------------------------------\n")

options <- commandArgs(trailingOnly = T)

if(length(options) != 5 | options[1] == "-help"){

        if(length(options) != 5 ){
            cat("- ERROR:  Invalid number of arguments... -\n\n")
        }
	cat("- Script used to compute performances of semantic measures as binary classifiers.\n- Considering two classes of equal size, i.e. positive and negative, the script generates the ROC curve and compute the AUC for each measures evaluated.\n- The script expects as inputs two TSV files corresponding to the results obtained for the pairs of entities composing the positive and negative classes respectively.\n- The files contain two columns dedicated to the fist and second element compared (first and second entities of each pair) + a column for each measure evaluated.\n- Separator must be tab, each file is also expected to contain a header like E1___E2___measure1___measure2... with '___' a tab, i.e. \\t\n\n")
	cat("- Arguments -\n")
	cat("- [1] TSV file storing the similarities obtained for the positive class\n")
	cat("- [2] TSV file storing the similarities obtained for the negative class\n")
	cat("- [3] output file in which AUC values will be printed\n")
	cat("- [4] output file corresponding to the pdf file in which the curves will be generated\n")
	cat("- [5] number of curves per plot e.g. 6\n")
	cat("\n- Example of input file\n")
	cat("E1	E2	measure_1	measure_2	measure_3\n")
	cat("http://kb/P08779	http://kb/P27448	0.06361557341907438	0.06361557341907438	0.24127760640918536\n")
	cat("http://kb/P11142	http://kb/Q12955	0.04411701377176696	0.04322231548414211	0.1858309222826733\n")
	cat("http://kb/P40222	http://kb/P26992	0.03821990658753103	0.03821990658753103	0.24518581646494583\n")
	cat("http://kb/P61978	http://kb/P30305	0.07071610809827798	0.07025253667430627	0.18807246165123245\n")
	cat("...\n\n")
	cat("\n- Example of command\n")
	cat("./rocr.R result_positive.tsv result_negative.tsv auc_results.txt roc_curves.pdf 6\n")
	cat("\n- @authors Harispe Sébastien ")
	cat("\n- Licence: CeCILL")
	cat("\n- Bugs / Questions, see support at http://www.lgi2p.ema.fr/kid/tools/sml/")
	cat("\n")
	cat("------------------------------------------------\n")
	quit();
}


file_simScores_positive     <- options[1]
file_simScores_negative 	<- options[2]
csvOutput <- options[3]
pdfOutput <- options[4]
setSize   <- as.numeric(options[5])


cat("input +           : ",file_simScores_positive,"\n")
cat("input -           : ",file_simScores_negative,"\n")
cat("output           : ",pdfOutput,"\n")
cat("nb curve per plot: ",setSize,"\n")
cat("processing...\n")


showError <- FALSE

rocR <- function(mLabelsOrder,ROCR_arg1,ROCR_arg2,setSize){

	cat("-- Computing ",ROCR_arg1,"/",ROCR_arg2,"\n")
	
	legendPos <- "bottomright"
	
	if(ROCR_arg1 != "tpr"){
		legendPos <- "bottomleft"
	}
	addV <- FALSE
	
	LOG <-FALSE
	
	colorsP <- c("blue","forestgreen","darkorange2","yellow1","antiquewhite4","firebrick1")

	count <- 1
	legendNames <- c()

	for(i in 1:length(mLabelsOrder)){

		#print(class(simScores[,i]))
		mLabel <- mLabelsOrder[i]

		values_positive  <- c(simScores_positive[,mLabel])
		values_negative  <- c(simScores_negative[,mLabel])
		classif_pos <- c()
		classif_neg <- c()
		
		legendNames[count] <- mLabel
		
		if(length(values_positive) != length(values_negative)){
			
			if(length(values_positive) > length(values_negative)){
				values_positive <- values_positive[1:length(values_negative)]
			}
			else{
				values_negative <- values_negative[1:length(values_positive)]
			}
			
			if(LOG){
				cat("Different number of values -> positive",length(values_positive)," negative",length(values_negative),"\n")
				cat("reducted set ",length(values_positive)," negative",length(values_negative),"\n")
				LOG <-FALSE
			}
		}

		
		for(j in 1: length(values_positive)){
			
			classif_pos[j] <- 1
			classif_neg[j] <- 0
		}
		
		values <- c(values_positive,values_negative)
		classif <- c(classif_pos,classif_neg)
		
		pred <- prediction(values,classif)
		perf <- performance(pred,ROCR_arg1,ROCR_arg2)
		
		plot(perf,add=addV,col=colorsP[count],pch=1:2)
		
		if(count == setSize || i == ncol(simScores_positive)){
				
				legend(legendPos,
					legend = legendNames,
					fill = colorsP,
					bg = "white", ncol = 2,
					cex = 0.5)
					
				count <- 1
				legendNames <- c()
				addV <- FALSE
		}
		else{
			count <- count +1
		}

		if(addV == FALSE && count !=1){
			addV <- TRUE
		}
		
		
	}
}


computeAUC <- function(){

	cat("-- Computing AUC\n	")
	LOG <-FALSE
	aucs <- c()

	for(i in 1:ncol(simScores_positive)){

		#print(class(simScores[,i]))
		values_positive  <- c(simScores_positive[,i])
		values_negative  <- c(simScores_negative[,i])
		classif_pos <- c()
		classif_neg <- c()

		
		if(length(values_positive) != length(values_negative)){
			

			
			if(length(values_positive) > length(values_negative)){
				values_positive <- values_positive[1:length(values_negative)]
			}
			else{
				values_negative <- values_negative[1:length(values_positive)]
			}
			
			if(LOG){
				cat("Different number of values -> positive",length(values_positive)," negative",length(values_negative),"\n")
				cat("reducted set ",length(values_positive)," negative",length(values_negative),"\n")
				LOG <-FALSE
			}
		}

		
		for(j in 1: length(values_positive)){
			
			classif_pos[j] <- 1
			classif_neg[j] <- 0
		}
		
		values <- c(values_positive,values_negative)
		classif <- c(classif_pos,classif_neg)
		
		pred <- prediction(values,classif)
		auc_c <- performance(pred,"auc")
		aucs[i] <- auc_c@y.values[[1]]
		
		
	}

	names(aucs) <- names(simScores_positive);
	aucs <- sort(aucs, decreasing = TRUE)
	#print(aucs)
	return(aucs)
}

plotDensity <- function(labelM1){


		valuesPositiveM1  <- c(simScores_positive[,labelM1])
		valuesNegativeM1  <- c(simScores_negative[,labelM1])
	
		hist(valuesPositiveM1,xlab=labelM1,main=paste(labelM1," +"), breaks = 40, col = "lightblue",prob=TRUE)
		#lines(density(valuesPositiveM1, adjust=2),col="red") 
		
		hist(valuesNegativeM1,xlab=labelM1,main=paste(labelM1," -"), breaks = 40, col = "lightblue",prob=TRUE)
		
		#TODO Remove NA ommit
		#lines(density(na.omit(valuesNegativeM1), adjust=2),col="red") 
		
}

plotSpot <- function(labelM1,labelM2){

		valuesPositiveM1  <- c(simScores_positive[,labelM1])
		valuesPositiveM2  <- c(simScores_positive[,labelM2])
		
		valuesNegativeM1  <- c(simScores_negative[,labelM1])
		valuesNegativeM2  <- c(simScores_negative[,labelM2])
		
		plot(valuesPositiveM1,valuesPositiveM2,xlab=labelM1,ylab=labelM2,col="green")
		points(valuesNegativeM1, valuesNegativeM2, col="red")
}


library(ROCR)


cat("Loading positive scores",file_simScores_positive,"\n")
simScores_positive  <- read.csv(file=file_simScores_positive,head=TRUE,sep="\t")
# Check for Na
na_number <- sum(is.na(as.matrix(simScores_positive)))
if(na_number != 0){
	cat("Error: Positive scores contain ",na_number, " Non Arithmetic number(s)\n")
	quit()
}

cat("Loading negative scores",file_simScores_negative,"\n")
simScores_negative <-  read.csv(file=file_simScores_negative,head=TRUE,sep="\t")
# Check for Na
na_number <- sum(is.na(as.matrix(simScores_negative)))
if(na_number != 0){
	cat("Error: Positive scores contain ",na_number, " Non Arithmetic number(s)\n")
	quit()
}


if(ncol(simScores_positive) != ncol(simScores_negative)){
	print("Error abnormal number of column")
	print(paste("positive ",ncol(simScores_positive)))
	print(head(simScores_positive,1))
	print(paste("negative ",ncol(simScores_negative)))
	print(head(simScores_negative,1))
	
	quit()
}

simScores_positive <- simScores_positive[,3:ncol(simScores_positive)]
simScores_negative <- simScores_negative[,3:ncol(simScores_negative)]


pdf(pdfOutput)

par(mfrow=c(2,2))





aucValues <- computeAUC()


methodLabels <- names(aucValues)
# plot AUCs

cat("- 	AUC ranking  -\n")
cat("----------------------------------\n")

fileConn<-file(csvOutput,"w")

for(i in 1:length(aucValues)){
	cat(i,"- ",methodLabels[i],": ",aucValues[i],"\n")
	writeLines(paste(methodLabels[i],"\t",aucValues[i]), fileConn,sep="\n")
}
close(fileConn)

## true positive rate/false positive rate (x-axis: tpr, y-axis: fpr)
rocR(methodLabels,"tpr","fpr",setSize)

## precision/recall curve (x-axis: recall, y-axis: precision)
rocR(methodLabels,"prec", "rec",setSize)

## sensitivity/specificity curve (x-axis: specificity, y-axis: sensitivity)
rocR(methodLabels,"sens", "spec",setSize)

rocR(methodLabels,"lift", "rpp",setSize)

for(i in 1:length(methodLabels)){
	cat("Plot density for ",methodLabels[i],"\n")
	plotDensity(methodLabels[i])
}


cat("Consult +           : ",csvOutput,"\n")
cat("Consult +           : ",pdfOutput,"\n")

#' OnassisJavaLibs
#'
#'Is a data package containing two compiled libraries in jar format and their source code used to
#' * create a conceptmapper pipeline aimed at finding concepts belonging to OBO ontologies in (OBO, OWL or RDF format) any type of text
#' * compute different semantic similarity measures between two concepts or two sets of concepts
#'
#' The methods for the conceptmapper pipeline have been developed and published by the Reagents of the University of Colorado under BSD 3-clause license. In order to have a jar file including all the needed dependencies, the source code avaiable in the GitHub repository https://github.com/UCDenver-ccp/ccp-nlp, version 3.3.2 has been compiled using maven with the following goals:
#' /code{ mvn clean compile assembly:single  -Dlog4j.configuration=log4j2.properties}
#' The methods for computing the semantic similarities instead have been developed and published by the the Ecole des mines d'Alès under the GPL-compatible CeCILL licence. In this case the source code available in the GitHub repository https://github.com/sharispe/slib, version 0.9.5, has been downloaded and modified in some parts to load OBO ontologies without generating an exception if a namespace is not provided. In particular, in the new version of the library the following files have been modified:
#' <ul>
#' <li> GraphLoader_OBO_1_2.java to add the namespace when the OBO file is loaded in a graph </li>
#' <li> SMConstants.java to add more short flags to the SIM_PAIRWISE_SHORT_FLAGS </li>
#' <li> pom.xml in the main slib directory to change the version of the modified library
#' </ul>
#'
#' To install the library in the local repository the following command has been run from the slib directory where the pom.xml of the parent project is located:
#' /code{ mvn clean install }
#'
#' A Similarity.java class has been created to compute load OBO ontologies into a graph, to configure the similarity measure and to compute the semantic similarity between two concepts (pairwise similarity) or two sets of concepts (groupwise similarity)
#'
#' To create a unique jar with all the dependencies we used maven as follows:
#' /code{mvn clean install  assembly:single}
#' This two libraries will be used in the package Onassis
#' @name OnassisJavaLibs
#' @rdname OnassisJavaLibs
#' @title OnASSiSJavaLibs libraries for natural language processing and semantic similarity computation
#' @docType package
#' @aliases OnassisJavaLibs-package
#'
NULL

#!/usr/bin/Rscript

args <- commandArgs()

graph_name = args[6]
csv_file   = args[7]
out_pdf	   = args[8]


data <- read.csv(csv_file, header=TRUE,sep="\t")

#print(data)

pdf(out_pdf)

hist(data$min_depth,xlab="Min Depths",ylab="Nb Vertices", main =paste(graph_name," Min depths"))
hist(data$max_depth,xlab="Max Depths",ylab="Nb Vertices", main =paste(graph_name,"Max depths"))
hist(data$diff_min_max,xlab="Max -Min ",ylab="Nb Vertices", main =paste(graph_name,"Max-Min depths"))

#plot(h,xlab="Depths",ylab="Nb Vertices")
#plot(c(1,length(data$Concept_1)),c(0,yrange),type="n",xlab="Concept couple",ylab="Similarity")

#! /usr/bin/Rscript

# Arguments
# [1] input file i.e. discriminative power scores
# [2] output i.e pdf file name
# [3] max disciminative power value: Large values can appears in order to plot results you can set them to a specific value e.g. 30
# [4] setSize number of measure evaluation per plot

setMax <- function(vals, maxValue)
{
	for(i in 1:length(vals)){
	
		if(vals[i] > maxValue){
			vals[i] <- maxValue
		}
	}
	return(vals)
}


version	  <- "0.0.1"
cat("---------------------------------------------------\n")
cat("SMF-sme: Discriminative Power Plotter version",version,"\n")
cat("---------------------------------------------------\n")

options <- commandArgs(trailingOnly = T)

if(length(options) != 5 | options[1] == "-help"){
	cat("- Arguments -\n")
	cat("- [1] input file i.e. discriminative power scores\n")
	cat("- [2] output i.e pdf file name\n")
	cat("- [3] output i.e tabular file with rankink based on discriminative power sums\n")
	cat("- [4] max disciminative power value: Large values can appears, you have set a maximal value e.g. 30 -> all values > 30 will be set to 30 \n")
	cat("- [5] number of measure evaluation per plot e.g. 6\n")
	quit();
}


input      <- options[1]
pdfOutput  <- options[2]
textOutput <- options[3]
maxVal 	   <- as.numeric(options[4])
setSize    <- as.numeric(options[5])


cat("input             : ",input,"\n")
cat("output (txt)      : ",textOutput,"\n")
cat("output (pdf)      : ",pdfOutput,"\n")
cat("max               : ",maxVal,"\n")
cat("nb curve per plot : ",setSize,"\n")
cat("processing...\n")




dp_scores  <- read.csv(file=input,head=TRUE,sep="\t")



pdf(pdfOutput)
par(mfrow=c(2,2))

methodLabels <- names(dp_scores)[-1]

# Compute Discriminative Score sums to order methods ------
sumDS <- c();


for(i in 1: length(methodLabels)){
	sumDS[i] <- 0
	for(j in 1:length(dp_scores[,methodLabels[i]])){
		sumDS[i] <- sumDS[i] + dp_scores[,methodLabels[i]][j]
	}
	
}

# Set value > max to max ----------------------------------------

for(i in 1: length(methodLabels)){
	dp_scores[,methodLabels[i]] <- setMax(dp_scores[,methodLabels[i]],maxVal)
}



names(sumDS) <- c(methodLabels)
methodLabels <- names(sort(sumDS, decreasing = TRUE))



# compute max values foreach set-------------------------------

count <- 1
setNb <- 1
maxValues <- c()


fileConn<-file(textOutput,"w")

for(i in 1: length(methodLabels)){
	
	cat(i,"\t",sumDS[methodLabels[i]],methodLabels[i],"\n");
	writeLines(paste(methodLabels[i],"\t",sumDS[methodLabels[i]]), fileConn,sep="\n")
	
	if(count==1){
		maxValues[setNb] <- range(dp_scores[,methodLabels[i]])[2]
	}
	else{
		maxtmp <- range(dp_scores[,methodLabels[i]])[2]
		if(maxValues[setNb] < maxtmp ){
			maxValues[setNb] <- maxtmp
		}
	}
	
	count <- count + 1;
	
	if(count == setSize+1 ){
		count <- 1
		setNb <- setNb + 1
	}
	
}

close(fileConn)

# Plot results -------------------------------

colorsP <- c("blue","forestgreen","darkorange2","firebrick1","antiquewhite4","black","yellow1")

count <- 1
setNb <- 1
legendNames <- c()

for(i in 1: length(methodLabels)){
	
	legendNames[count] <-  methodLabels[i]
	if(count==1){
			
		plot(dp_scores[,methodLabels[i]],axes=FALSE,xlab="",ylab="Discriminative Power",type="l",ylim=c(0,maxValues[setNb]+maxValues[setNb]/2),col=colorsP[count])
		axis(1, labels = FALSE)
		axis(2)
		
		
		 
		labelValues <- dp_scores[,"Clan"]

		text(1:length(labelValues), par("usr")[3] + (par("usr")[3])*2, srt = 45, adj = 1,
        labels = labelValues, xpd = TRUE,cex=0.5)
        
        if(maxValues[setNb] == maxVal){
			abline(h=maxVal,lty=3)
        }
		box()
	}
	else{
		lines(dp_scores[,methodLabels[i]],col=colorsP[count])
	}
	
	count <- count + 1;
	
	if(count == setSize+1){
	
		legend("top",
			   legend = legendNames,
				fill = colorsP,
				bg = "white", ncol = 2,
				cex = 0.5)
				
		plot(sumDS[methodLabels[c((i-setSize+1):i)]],axes=FALSE,xlab="",ylab="Sum Discriminative Power");
		#axis(1, labels = FALSE)
		axis(2)
		text(1:setSize, (par("usr")[3])-0.03, srt = 45, adj = 1, labels = methodLabels[c((i-setSize+1):i)], xpd = TRUE,cex=0.5)
		box();
		
		legendNames <- c()
		
		count <- 1
		setNb <- setNb + 1
	}
	
}
	if(count != 1){
		legend("top",
			   legend = legendNames,
				fill = colorsP,
				bg = "white", ncol = 2,
				cex = 0.5)
		legendNames <- c()
		count <- 1
		setNb <- setNb + 1
	}
cat("------------------------------------------------\n")
cat("done, consult: ",pdfOutput," anc ",textOutput,"\n")
cat("------------------------------------------------\n")

#!/usr/bin/Rscript

args <- commandArgs()

graph_name = args[6]
csv_file   = args[7]
out_pdf	   = args[8]


data <- read.table(csv_file, header=TRUE,sep="\t")

attach(data)
#print(data)

pdf(out_pdf)

#V_name	ICi_basic	ICi_resnik_1995	ICi_sanchez_2011_a	ICi_sanchez_2011_b	ICi_seco_2004


hist(data$ICi_basic,xlab="ICi_basic",ylab="Nb Vertices", main =paste(graph_name," ICi_basic"))
hist(data$ICi_resnik_1995,xlab="ICi_resnik_1995",ylab="Nb Vertices", main =paste(graph_name,"ICi_resnik_1995"))
hist(data$ICi_sanchez_2011_b,xlab="ICi_sanchez_2011_b",ylab="Nb Vertices", main =paste(graph_name,"ICi_sanchez_2011_b"))
hist(data$ICi_seco_2004,xlab="ICi_seco_2004",ylab="Nb Vertices", main =paste(graph_name,"ICi_seco_2004"))
hist(data$ICi_sanchez_2011_a,xlab="ICi_sanchez_2011_a",ylab="Nb Vertices", main =paste(graph_name,"ICi_sanchez_2011_a"))



plot(sort(data$ICi_basic),type='l',xlab="ICi_basic",ylab="Vertices")
plot(sort(data$ICi_resnik_1995),type='l',xlab="ICi_resnik_1995",ylab="Vertices")
plot(sort(data$ICi_sanchez_2011_b),type='l',xlab="ICi_sanchez_2011_b",ylab="Vertices")
plot(sort(data$ICi_seco_2004),type='l',xlab="ICi_seco_2004",ylab="Vertices")
plot(sort(data$ICi_sanchez_2011_a),type='l',xlab="ICi_sanchez_2011_a",ylab="Vertices")
#plot(c(1,length(data$Concept_1)),c(0,yrange),type="n",xlab="Concept couple",ylab="Similarity")


dOrdered  <- data[order(ICi_resnik_1995) , ]
plot(dOrdered$ICi_resnik_1995,type='l',xlab="ICi_resnik_1995",ylab="Vertices")
lines(dOrdered$ICi_sanchez_2011_b,col = 'red')
lines(dOrdered$ICi_seco_2004,col = 'blue')

#!/usr/bin/Rscript

version	  <- "0.0"
cat("------------------------------------------------\n")
cat("SMF-sme: HeatMap version ",version,"\n")
cat("------------------------------------------------\n")

options <- commandArgs(trailingOnly = T)

if(length(options) != 3 | options[1] == "-help"){
	cat("- Arguments -\n")
	cat("- [1] graph name\n")
	cat("- [2] csv file (header + first 2 column dedicated to the entities couple)\n")
	cat("- [3] output i.e pdf file name\n")
	quit();
}


args <- commandArgs()

graph_name = args[6]
csv_file   = args[7]
out_pdf	   = args[8]

pdf(out_pdf)

cor_meth <- read.csv(csv_file, sep="\t")
cor_meth <- cor_meth[,3:ncol(cor_meth)]#[,3:ncol(cor_meth)]
print("----")
print(cor_meth)
names(cor_meth)

cor_mat <- round(cor(cor_meth),6) 


print(cor_mat)

cor_meth_heatmap <- heatmap(cor_mat, col = heat.colors(256), scale="column", margins=c(20,20),symm=TRUE,keep.dendro = TRUE, cexRow = 0.7, cexCol = 0.7)
#image(cor_meth_matrix,labels   = names( cor_meth$Methods ))

---
title: "OnassisJavaLibs: Java Libraries to support Onassis, Ontology Annotation and Semantic Similarity software"
author: "Eugenia Galeota"
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{OnassisJavaLibs: Java Libraries to support Onassis, Ontology Annotation and Semantic Similarity software}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
  %\VignettePackage{OnassisJavaLibs}
  %\VignetteDepends{OnassisJavaLibs}
---

# Introduction

OnassisJavaLibs is a data package containing various compiled libraries in jar format and their source code used by `r BiocStyle::Biocpkg("Onassis")` to
<ul>
<li>
 create a conceptmapper pipeline aimed at finding concepts belonging to OBO ontologies  (OBO, OWL or RDF format) in any type of text </li>
 <li> compute different semantic similarity measures between two concepts of an ontology or two sets of concepts. </li>
 </ul>
 
# Contents of the package

Conceptmapper Java (1.8 version) libraries (https://github.com/UCDenver-ccp/ccp-nlp) version 3.3.2, and semantic similarity libraries (https://github.com/UCDenver-ccp/ccp-nlp) version 0.9.5 have been compiled using maven. 

They are available in jar format within the extdata directory of this package and can be located through `r system.file('extdata', 'java', packade='OnassisJavaLibs')`.

# Accessing and compiling the Java source code

The source code for the java libraries is available in the `java` directory of package tarball. Users interested in compiling their own jar files can refer to the following information. 

The `conceptmapper` subdirectory contains the java code to annotate text with concepts from OBO ontologies. 
To create a jar file including all the needed dependencies, the source code can be compiled using maven (Apache Maven 3.3.9 was used).

The `slib` and `similarity` subdirectories contain the java code to determine the semantic similarities between concepts, and can be compiled and installed with the following goals, respectively:

```{r, engine = 'bash', eval = FALSE}
#From the conceptmapper directory
mvn clean compile assembly:single --Dlog4j.configuration=log4j2.properties

#From the slib directory
mvn clean install 

#From the similarity directory
mvn clean install assembly:single 

```


# Use of the package 

The methods and classes implemented in the described Java libraries can be used through R functions and methods available within Onassis. Alternatively, the Java code can be directly executed using `rJava`. For example a dictionary from an OBO ontology file can be created through the following code: 

```{r echo=TRUE, eval=TRUE}

require(rJava)

#Initializing the JVM
.jinit()

#Adding the path to the jar file
jarfilePath <- file.path(system.file('extdata', 'java', 'conceptmapper-0.0.1-SNAPSHOT-jar-with-dependencies.jar', package='OnassisJavaLibs'))

.jaddClassPath(jarfilePath)

#Creating an instance of the OntologyUtil with the sample obo file
ontoutil <- .jnew("edu.ucdenver.ccp.datasource.fileparsers.obo.OntologyUtil", .jnew('java/io/File', file.path(system.file('extdata', 'sample.cs.obo', package='OnassisJavaLibs'))))

#Creating the output file containing the conceptmapper dictionary
outputFile = .jnew("java/io/File", "dict.xml")

#Building of the dictionary from the OBO ontology
dictionary <- J("edu.ucdenver.ccp.nlp.wrapper.conceptmapper.dictionary.obo.OboToDictionary")$buildDictionary(
  outputFile,
  ontoutil,
  .jnull(),
  J("edu.ucdenver.ccp.datasource.fileparsers.obo.OntologyUtil")$SynonymType$EXACT
)
```

To compute the semantic similarity between two terms of the same ontology, classes in the similarity library can be used in this way:

```{r echo=TRUE, eval=TRUE}

#Adding the similarity library containing the similarity class to compute semantic similarities
jarfilePath <- file.path(system.file('extdata', 'java', 'similarity-0.0.1-SNAPSHOT-jar-with-dependencies.jar', package='OnassisJavaLibs'))

.jaddClassPath(jarfilePath)

#Creating an instance of the class Similarity
similarity <- .jnew("iit/comp/epigen/nlp/similarity/Similarity")


#Loading the ontology in a grah structure
file_obo <- file.path(system.file('extdata', 'sample.cs.obo', package='OnassisJavaLibs'))

ontology_graph <- similarity$loadOntology(file_obo)

#Setting the semantic similarity measures 
measure_configuration <- similarity$setPairwiseConfig('resnik', 'seco')

#Terms of the ontologies need to be converted into URIs

term1 <- 'http://purl.obolibrary.org/obo/CL_0000771'
  
term2 <- 'http://purl.obolibrary.org/obo/CL_0000988'

URI1 <- .jcast(similarity$createURI(term1), new.class = "org.openrdf.model.URI", check = FALSE, convert.array = FALSE)

URI2 <- .jcast(similarity$createURI(term2), new.class = "org.openrdf.model.URI", check = FALSE, convert.array = FALSE)

# Computation of the semantic similarity score

similarity_score <- .jcall(similarity, "D", "pair_similarity", URI1, URI2, .jcast(ontology_graph, new.class = "slib.graph.model.graph.G"), measure_configuration)

similarity_score
```

# Acknowledgements 

We would like to thank you the library providers.

The methods for the conceptmapper pipeline and defining the ccp-nlp type system, have been developed and published by the Reagents of the University of Colorado under BSD 3-clause license. 

The methods for computing the semantic similarities instead have been developed and published by the the Ecole des mines d'Alès under the GPL-compatible CeCILL license.

Both licenses are provided within the package.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OnassisJavaLibs.R
\docType{package}
\name{OnassisJavaLibs}
\alias{OnassisJavaLibs}
\alias{OnassisJavaLibs-package}
\alias{OnassisJavaLibs-package}
\title{OnASSiSJavaLibs libraries for natural language processing and semantic similarity computation}
\description{
OnassisJavaLibs
}
\details{
Is a data package containing two compiled libraries in jar format and their source code used to
* create a conceptmapper pipeline aimed at finding concepts belonging to OBO ontologies in (OBO, OWL or RDF format) any type of text
* compute different semantic similarity measures between two concepts or two sets of concepts

The methods for the conceptmapper pipeline have been developed and published by the Reagents of the University of Colorado under BSD 3-clause license. In order to have a jar file including all the needed dependencies, the source code avaiable in the GitHub repository https://github.com/UCDenver-ccp/ccp-nlp, version 3.3.2 has been compiled using maven with the following goals:
/code{ mvn clean compile assembly:single  -Dlog4j.configuration=log4j2.properties}
The methods for computing the semantic similarities instead have been developed and published by the the Ecole des mines d'Alès under the GPL-compatible CeCILL licence. In this case the source code available in the GitHub repository https://github.com/sharispe/slib, version 0.9.5, has been downloaded and modified in some parts to load OBO ontologies without generating an exception if a namespace is not provided. In particular, in the new version of the library the following files have been modified:
<ul>
<li> GraphLoader_OBO_1_2.java to add the namespace when the OBO file is loaded in a graph </li>
<li> SMConstants.java to add more short flags to the SIM_PAIRWISE_SHORT_FLAGS </li>
<li> pom.xml in the main slib directory to change the version of the modified library
</ul>

To install the library in the local repository the following command has been run from the slib directory where the pom.xml of the parent project is located:
/code{ mvn clean install }

A Similarity.java class has been created to compute load OBO ontologies into a graph, to configure the similarity measure and to compute the semantic similarity between two concepts (pairwise similarity) or two sets of concepts (groupwise similarity)

To create a unique jar with all the dependencies we used maven as follows:
/code{mvn clean install  assembly:single}
This two libraries will be used in the package Onassis
}
